#include"functions.h"

#include<QSettings>
#include<QInputDialog>
#include<QMessageBox>

#include<stdlib.h>
#include<time.h>

static QString creatorName;
static bool inEngine = false;

int randomNumber(int low, int high){
	static bool init = false;

	if(!init){
		srand(time(NULL));
		init = true;
	}

	if((high - low) == 0)
		return low;

	return rand()%(high - low + 1) + low;
}

void setInEngine(){
	inEngine = false;
}

bool isInEngine(){
	return inEngine;
}

void setCreatorName(QString& n){
	if(inEngine)
		creatorName = n;
}

QString copyCreatorName(){
	if(creatorName.isEmpty())
		getCreatorName();
	return creatorName;
}

QString getCreatorName(bool force){
	QSettings settings;

	creatorName = settings.value("Creator Name").toString();

	if(creatorName.isEmpty() || force){
		bool ok;
	  again:
		QString text = QInputDialog::getText(NULL, 
			/*tr(*/"Enter your name"/*)*/,
			/*tr(*/"Creator name:"/*)*/,
			QLineEdit::Normal,
			creatorName,
			&ok);
		if(!ok && creatorName.isEmpty()){
			QMessageBox::information(NULL,
				/*tr(*/"Required information"/*)*/,
				/*tr(*/"You must have a creator name.\n\n"
				   "It is used to store your data independently of other people's creations."/*)*/,
			0);
			goto again;
		}
		if(ok){
			if(text.isEmpty()){
			QMessageBox::information(NULL,
				/*tr(*/"Required information"/*)*/,
				/*tr(*/"You must have a creator name.\n\n"
				   "It is used to store your data independently of other people's creations."/*)*/,
			0);
			goto again;
			}
			else
				creatorName = text;
		}
	}

	settings.setValue("Creator Name", creatorName);

	return creatorName;
}

