#include"mframeanimation.h"

#include"functions.h"

#include<QPainter>

MFrameAnimation::MFrameAnimation(){
	type = 1;
	width = 0;
	height = 0;
	vermagic = 1;
	currentFrame = 0;
	currentTick = 0;
	currentTickNeeded = 0;
}

void MFrameAnimation::draw(QPainter* screen, QPoint where){
	screen->drawImage(where, frames[currentFrame].getImage());
}

bool MFrameAnimation::tick(){
	if(frames.count() == 0)
		return false;

	currentTick++;
	if(currentTick >= currentTickNeeded){
		currentTick = 0;
		currentFrame++;
		if(currentFrame >= frames.count())
			currentFrame = 0;

		currentTickNeeded = randomNumber(frames[currentFrame].getMinTime(), frames[currentFrame].getMaxTime());

		return true;
	}
	return false;
}

bool MFrameAnimation::loadFromData(QDataStream& in, int vermagic){
	if(vermagic < 0)
		return false;

	qint32 numFrames;
	in >> numFrames;

	for(int a = 0; a < numFrames; a++){
		qint32 lt, ut;
		QString fn;

		in >> lt;
		in >> ut;
		in >> fn;

		MFilename mfn(fn);

		frames.append(MFrame(mfn,(int)lt,(int)ut));
	}

	return true;
}

bool MFrameAnimation::saveToData(QDataStream& out){
	qint32 numFrames = frames.count();
	out << numFrames;

	for(int a = 0; a < numFrames; a++){
		qint32 lt, ut;
		QString fn;

		lt = frames[a].getMinTime();
		ut = frames[a].getMaxTime();
		fn = frames[a].getForFile();

		out << lt;
		out << ut;
		out << fn;
	}


	return true;
}

