#include"mimage.h"

#include"mframeanimation.h"
#include"mscriptedanimation.h"
#include"mstaticimage.h"

#include<QFile>

MImage::~MImage(){

}

MImage::MImage(){

}

MImage* MImage::load(MFilename& filename){
	QString f;

	if(!filename.isValid())
		return NULL;

	f = filename.forDisk();
	QFile file(f);
	file.open(QIODevice::ReadOnly);

	QDataStream in(&file);

	quint8 a;
	in >> a;
	if(a != 'A')
		if(a == 0x89){
			//assume it is a png
			file.close();
			QImage img(f);
			if(img.isNull())
				return NULL;
			MImage* mi = new MStaticImage(img);
			mi->type = 2;
			mi->width = img.width();
			mi->height = img.height();
			return mi;
		}else
			return NULL;
	in >> a;
	if(a != 'M')
		return NULL;
	in >> a;
	if(a != '3')
		return NULL;
	in >> a;
	if(a != 'a')
		return NULL;

	qint16 type;
	in >> type;

	qint16 vermagic;
	in >> vermagic;

	QString creatorName;

	in >> creatorName;

	qint16 twidth, theight;

	in >> twidth;
	in >> theight;

	MImage* mi = NULL;

	switch(type){
		case 0:
			mi = new MScriptedAnimation();
		break;
		case 1:
			mi = new MFrameAnimation();
		break;
		default:
			return NULL;
	}

	mi->width = twidth;
	mi->height = theight;
	mi->creator = creatorName;
	mi->vermagic = vermagic;
	mi->type = type;

	if(mi->loadFromData(in, vermagic) == false){
		delete mi;
		return NULL;
	}

	return mi;
}

bool MImage::save(MFilename& Filename){
	QString f;

	if(!Filename.isValid())
		return false;

	f = Filename.forDisk();
	QFile file(f);
	file.open(QIODevice::WriteOnly);

	QDataStream out(&file);

	out << (qint8)'A';
	out << (qint8)'M';
	out << (qint8)'3';
	out << (qint8)'a';

	out << type;

	out << vermagic;

	out << creator;

	out << width;
	out << height;

	return saveToData(out);
}

int MImage::getWidth(){
	return width;
}

int MImage::getHeight(){
	return height;
}

int MImage::getType(){
	return type;
}

QString MImage::getCreator(){
	return creator;
}

MImage::MImage(MFilename& filename){
	load(filename);
}

