#ifndef MMAP_H
#define MMAP_H

#include<QPainter>
#include<QPoint>
#include<QList>
#include<QString>

#include"mfilename.h"
#include"mtile.h"

class MMap{
  public:
	MMap();
	MMap(int w, int h);
	~MMap();

	bool tickBackground();
	bool tickMain();
	bool tickOverlay();

	void drawBackground(QPainter* p, QPoint where = QPoint(0,0), int x = 0, int y = 0);
	void drawMain(QPainter* p, QPoint where = QPoint(0,0), int x = 0, int y = 0, int w = 20, int h = 15);
	void drawOverlay(QPainter* p, QPoint where = QPoint(0,0), int x = 0, int y = 0);

	bool load(MFilename fn);
	bool save(MFilename fn);

  private:
	QString name;

	MFilename wallpaper;
	MFilename overlay;
	bool backgroundIsMobile;
	bool overlayIsMobile;
// or color or tile
	bool loops;
	bool randomBattles;
	bool canSave;
	bool nightAdvances;

	MFilename bgm;

	QList<MFilename> tilesUsed;

	QList<MTile> tiles;

	int height;
	int width;

	int * terrain;
//	stationary events
//	more scripting stuff

//	enemy domain datasets

	QString entryEvent;
	QString exitEvent;


	QString creator;

	friend class MapEdit;
	friend class MapWidget;
};

#endif

