#include"mtile.h"

#include<QFile>
#include<QDataStream>

/*
	MTile file format

	identifier: AM3t
	vermagic: word
	creator: qstring
	all the private data
*/

MTile::MTile(){
	creator = "default";
}

MTile::MTile(MFilename fn){
	load(fn);
	creator = "default";
}

MTile::~MTile(){

}

bool MTile::load(MFilename fn){
	QFile file(fn.forDisk());
	file.open(QIODevice::ReadOnly);

	QDataStream in(&file);

	qint8 b;

	in >> b;
	in >> b;
	in >> b;
	in >> b;

	qint16 vermagic;

	in >> vermagic;

	in >> creator;

	for(int a = 0; a < 6; a++){
		QString h;
		in >> h;
		animationNames[a] = MFilename(h);
	}

	in >> b;
	damage = b;
	in >> b;
	overdraw = b;
	in >> canWalk;
	canWalk = b;

	for(int a = 0; a < 6; a++){
		in >> b;
		canMove[a] = b;
	}

	for(int a = 0; a < 6; a++){
		in >> b;
		canPark[a] = b;
	}

	in >> battleFrequency;
	QString h;
	in >> h;
	battleBackground = MFilename(h);

	return true;

}

bool MTile::save(MFilename fn){
	QFile file(fn.forDisk());
	file.open(QIODevice::WriteOnly);

	QDataStream out(&file);

	out << (qint8) 'A';
	out << (qint8) 'M';
	out << (qint8) '3';
	out << (qint8) 't';

	out << (qint16) 1;

	out << creator;

	for(int a = 0; a < 6; a++)
		out << animationNames[a].forStoringInFile();

	out << (qint8) damage;
	out << (qint8) overdraw;
	out << (qint8) canWalk;

	for(int a = 0; a < 6; a++)
		out << (qint8) canMove[a];

	for(int a = 0; a < 6; a++)
		out << (qint8) canPark[a];

	out << battleFrequency;
	out << battleBackground.forStoringInFile();

	return true;
}

bool MTile::tick(){

}

void MTile::draw(QPainter* p, QPoint w, int n){

}

